// NOTE: This file is autogenerated with a-core_thesydekick/Entities/ACoreChip/ACoreChip/FGEN/TestGen.py 

package acorebase 

import chisel3._ 
import chiseltest._ 
import org.scalatest.flatspec.AnyFlatSpec 
import a_core_common._

class FPUBlockSpec extends AnyFlatSpec with ChiselScalatestTester {


////////////////////FADD////////////////////

  it should "do special case tests for FADD" in {
    test(new FPUBlock(XLEN=32)) { c =>

      c.io.control.op poke FPUOp.FADD_S
      c.io.control.rm poke RoundingMode.RNE

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h01000001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h81000001".U

    }
  }

////////////////////FSUB////////////////////

  it should "do special case tests for FSUB" in {
    test(new FPUBlock(XLEN=32)) { c =>

      c.io.control.op poke FPUOp.FSUB_S
      c.io.control.rm poke RoundingMode.RNE

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7fc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7fc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00800001".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h01000001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h80800001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h81000001".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00000000".U

    }
  }

////////////////////FMUL////////////////////

  it should "do special case tests for FMUL" in {
    test(new FPUBlock(XLEN=32)) { c =>

      c.io.control.op poke FPUOp.FMUL_S
      c.io.control.rm poke RoundingMode.RNE

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00000000".U

    }
  }

////////////////////FDIV////////////////////

  it should "do special case tests for FDIV" in {
    test(new FPUBlock(XLEN=32)) { c =>

      c.io.control.op poke FPUOp.FDIV_S
      c.io.control.rm poke RoundingMode.RNE

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7fffffff".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hffc00000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "h3f800000".U

      c.io.data.a poke "h00800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "hbf800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7fffffff".U
      c.io.data.out expect "h7fffffff".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h7f800000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "hff800000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00000000".U
      c.io.data.out expect "hff800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80000000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h00800001".U
      c.io.data.out expect "hbf800000".U

      c.io.data.a poke "h80800001".U
      c.io.data.b poke "h80800001".U
      c.io.data.out expect "h3f800000".U

    }
  }

////////////////////FSQRT////////////////////

  it should "do special case tests for FSQRT" in {
    test(new FPUBlock(XLEN=32)) { c =>

      c.io.control.op poke FPUOp.FSQRT_S
      c.io.control.rm poke RoundingMode.RNE

      c.io.data.a poke "h7fffffff".U
      c.io.data.out expect "h7fc00000".U

      c.io.data.a poke "h7f800000".U
      c.io.data.out expect "h7f800000".U

      c.io.data.a poke "hff800000".U
      c.io.data.out expect "h7fc00000".U

      c.io.data.a poke "h00000000".U
      c.io.data.out expect "h00000000".U

      c.io.data.a poke "h80000000".U
      c.io.data.out expect "h80000000".U

      c.io.data.a poke "h00800001".U
      c.io.data.out expect "h20000000".U

      c.io.data.a poke "h80800001".U
      c.io.data.out expect "h7fc00000".U

    }
  }
}
